Summary: The Frontier distribution of the Squid proxy caching server
Name: frontier-squid
Version: 2.7.STABLE9
%define dist sl5
%define release4source 8
%define releasenum 1
Release: %{?release4source}.%{?releasenum}.%{?dist}
Epoch: 11
License: GPL
Group: System Environment/Daemons
Packager: David Front <david.front@cern.ch>

%define frontiersquidutils frontier-squid-utils
%define distname squid
%define squidversion %{distname}-%{version}
%define frontiersquidrpm %{name}-%{version}-%{release4source}
# Caution: If defaultsquiduser is changed here, it should also be changed at frontier-awstats accordingly!
%define defaultsquiduser squid

%define executablemode 755
%define readablemode 644
%define readonlymode 444

# For LOG_DIR
%define logdirsquid /var/log/squid 
# For CACHE_DIR
%define cachedirsquid /var/cache/squid
# For RUN_DIR
%define rundirsquid /var/run/squid
# For ETC_DIR
%define etcdirsquid /etc/squid
# %{_libexecdir} is (/usr/sbin - or maybe) /usr/libexec/
%define libexecdirsquid %{_libexecdir}/squid 
# For SHARE_DIR: /usr/share/squid
# Equivalent: %define datadirsquid /usr/share/squid
%define datadirsquid %{_datadir}/squid

%define sourceConfig \
	SCFILE=%{etcdirsquid}/squidconf \
	if [ -s ${SCFILE} ]; then \
		source ${SCFILE} \
	else \
		export FRONTIER_USER=%{defaultsquiduser} \
	fi \
	if [ -z "${FRONTIER_USER}" ]; then \
		echo "ERROR: missing FRONTIER_USER" \
		exit 1 \
	fi \
	if [ "${FRONTIER_USER}" == 'root' ]; then \
		echo "ERROR: FRONTIER_USER can not be 'root'." \
		exit 1 \
	fi

# Macros to avoid directories names to start with //
%define nodup1 RPM_INSTALL_PREFIX_=`echo $RPM_INSTALL_PREFIX'"' | sed 's+/"++' | sed 's/"//'`
%define nodup2 RPM_BUILD_ROOT_=`echo ${RPM_BUILD_ROOT}%{prefix}'"' | sed 's+/"++' | sed 's/"//'`;RPM_BUILD_ROOT__=`echo ${RPM_BUILD_ROOT}%{prefix} | sed 's+//+/+g'`

Source0: http://frontier.cern.ch/dist/%{frontiersquidrpm}.tar.gz
Source1: %{name}.tar.gz
Conflicts: squid
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Prefix: /
Requires: bash >= 2.0

%description
Squid is a high-performance proxy caching server for Web clients,
supporting FTP, gopher, and HTTP data objects. Unlike traditional
caching software, Squid handles all requests in a single,
non-blocking, I/O-driven process. Squid keeps meta data and especially
hot objects cached in RAM, caches DNS lookups, supports non-blocking
DNS lookups, and implements negative caching of failed requests.
This squid distribution has been expecially tuned to work with the
CMS Frontier server to cache CMS and ATLAS DB entries retrieved from
an ORACLE back-end.

Squid consists of a main server program squid, a Domain Name System
lookup program (dnsserver), a program for retrieving FTP data
(ftpget), and some management and client tools.

%prep
%setup -n %{frontiersquidrpm} -q
tar zxf ../../SOURCES/%{name}.tar.gz

%build

# unpack squid code and patch it
cd ./squid
make INSTALL_DIR=$RPM_BUILD_ROOT PORT_ROOT=$PWD/.. unpack .common_patch

cd ../squid/work/%{squidversion}/
# put this package's version name in as the version for remote monitoring
sed -i "s/VERSION='\(.*\)'/VERSION='%{frontiersquidrpm}.%{releasenum}'/" configure
./configure \
   --prefix=%{prefix} \
   --exec_prefix=%{_usr} \
   --bindir=%{_bindir} \
   --libexecdir=%{libexecdirsquid} \
   --localstatedir=%{_var} \
   --sysconfdir=%{etcdirsquid} \
   --datadir=%{datadirsquid} \
   --disable-wccp \
   --enable-snmp \
   --disable-ident-lookups \
   --enable-storeio="ufs aufs"\
   --with-large-files

# Remark: Without this command, squid looks for configuration at a wrong directory 
make -j 4 "AM_MAKEFLAGS=DEFAULT_LOG_PREFIX=%{logdirsquid} DEFAULT_SWAP_DIR=%{cachedirsquid} DEFAULT_PID_FILE=%{rundirsquid}/squid.pid"

%install
rm -rf $RPM_BUILD_ROOT
%{nodup2}

# Consider; change not to need cd, as was before
cd ./squid/work/%{squidversion}/
%makeinstall \
   prefix=$RPM_BUILD_ROOT__ \
   sysconfdir=$RPM_BUILD_ROOT%{etcdirsquid} \
   localstatedir=$RPM_BUILD_ROOT/var \
   bindir=$RPM_BUILD_ROOT/%{_bindir} \
   libexecdir=$RPM_BUILD_ROOT%{libexecdirsquid}\
   datadir=$RPM_BUILD_ROOT%{datadirsquid} \
   "AM_MAKEFLAGS=DEFAULT_LOG_PREFIX=$RPM_BUILD_ROOT%{logdirsquid} DEFAULT_SWAP_DIR=$RPM_BUILD_ROOT%{cachedirsquid} DEFAULT_PID_FILE=$RPM_BUILD_ROOT%{rundirsquid}/squid.pid"
#TBD: revisit the following: avoid unneeded commands and take care to change mode to what looks to me more correct
mkdir -p ${RPM_BUILD_ROOT_}%{cachedirsquid} ${RPM_BUILD_ROOT_}%{logdirsquid}
chmod %{executablemode} $RPM_BUILD_ROOT_%{cachedirsquid} $RPM_BUILD_ROOT_%{logdirsquid}

# is here: BUILD/frontier-squid-2.7.STABLE9-5/squid/work/squid-2.7.STABLE9/doc
# is this?: install -m %{executablemode} %{_builddir}/%{frontiersquidrpm}/squid/work/%{squidversion}/doc/* $RPM_BUILD_ROOT_/usr/share/doc
mkdir -p $RPM_BUILD_ROOT_/usr/share/doc
install -m %{executablemode} ./doc/* $RPM_BUILD_ROOT_/usr/share/doc

mkdir -p $RPM_BUILD_ROOT_%{datadirsquid}
chmod %{executablemode} $RPM_BUILD_ROOT_%{datadirsquid}
mkdir -p $RPM_BUILD_ROOT_%{etcdirsquid}
chmod %{executablemode} $RPM_BUILD_ROOT_%{etcdirsquid}
install -m %{executablemode} %{_builddir}/%{frontiersquidrpm}/unproto.sh $RPM_BUILD_ROOT_%{etcdirsquid}
install -m %{executablemode} %{_builddir}/%{frontiersquidrpm}/postinstall.sh $RPM_BUILD_ROOT_%{etcdirsquid}
#this is a placeholder which postinstall.sh replaces when empty
#unfortunately it means that any .rpmnew file created is also empty
touch $RPM_BUILD_ROOT_%{etcdirsquid}/customize.sh

cd %{_builddir}/%{frontiersquidrpm}/squid
make INSTALL_DIR=$RPM_BUILD_ROOT_ proto_install
cd ../%{frontiersquidutils}
make INSTALL_DIR=$RPM_BUILD_ROOT_ proto_install

%clean
rm -rf $RPM_BUILD_ROOT

%files
#
%defattr(-,root,root)
#
#executable
%verify(not user group) %attr(%{executablemode},root,root) /usr/sbin/fn-local-squid.sh.proto
# fails, is libexecdirsquid not /usr/sbin/squid/? %attr(%{executablemode},root,root) %{libexecdirsquid}/*
%verify(not user group) %attr(%{executablemode},root,root) %{libexecdirsquid}/*
%verify(not user group) %attr(%{executablemode},root,root) /usr/sbin/squid
%verify(not user group) %attr(%{executablemode},root,root) /usr/sbin/multisquid
%verify(not user group) %attr(%{executablemode},root,root) /usr/bin/*
#
#default for %{etcdirsquid}: executable
%verify(not user group) %attr(%{executablemode},root,root) %{etcdirsquid}/*

%verify(not user group size md5 mtime) %config(noreplace) %attr(%{executablemode},root,root) %{prefix}/etc/squid/customize.sh

#some are config/readable
%ghost %attr(%{readonlymode},root,root) %{etcdirsquid}/squid.conf
%verify(not user group size md5 mtime mode) %config(noreplace) %attr(%{readablemode},root,root) %{etcdirsquid}/cachemgr.conf
%verify(not user group) %attr(%{executablemode},root,root) %{datadirsquid}/*
# readable
%verify(not user group) %attr(%{readonlymode},root,root) /usr/share/man/man8/*
%verify(not user group) %attr(%{readonlymode},root,root) /usr/share/doc/*

%pre
%sourceConfig

# 17/7/11 dfront, handling #3 at https://savannah.cern.ch/bugs/?77447
# bug #77447: Frontier squid installation problems in the UK:
# 3) squid user is not created. 
#    the standard rpm does create the user and it does so with the safest permission 
#    (nologin as shell and no password). 
#    There was a security incident because of this just a month ago from a site with the frontier squid got hacked. 
if ! getent passwd ${FRONTIER_USER} >/dev/null 2>&1 ; then
	echo "WARNING: Adding missing account: ${FRONTIER_USER}."
	#Other optional options: /usr/sbin/useradd -d /home/${FRONTIER_USER} -r -m ${FRONTIER_USER} >/dev/null 2>&1 || exit 1
	if ! /usr/sbin/useradd ${FRONTIER_USER} ; then
		echo "ERROR: failed to useradd ${FRONTIER_USER}"
		exit 1
	fi
	# Block shell access for user ${FRONTIER_USER} 
	if ! /usr/sbin/usermod -s /sbin/nologin ${FRONTIER_USER} ; then
		echo "ERROR: failed to usermod ${FRONTIER_USER}"
		exit 1
	fi
fi

serv=`eval service frontier-squid status 2>/dev/null`
if [ "x${serv}" = "xFrontier Squid is running" ]; then
   echo "Warning: the frontier-squid service is running."
   echo "Stopping the frontier-squid service"
   /sbin/service frontier-squid stop
fi

%post
%sourceConfig
case "$LANG" in
  bg*)
     DIR=Bulgarian
     ;;
  ca*)
     DIR=Catalan
     ;;
  cs*)
     DIR=Czech
     ;;
  da*)
     DIR=Danish
     ;;
  nl*)
     DIR=Dutch
     ;;
  en*)
     DIR=English
     ;;
  ea*)
     DIR=Estonian
     ;;
  fi*)
     DIR=Finnish
     ;;
  fr*)
     DIR=French
     ;;
  de*)
     DIR=German
     ;;
  he*)
     DIR=Hebrew
     ;;
  hu*)
     DIR=Hungarian
     ;;
  it*)
     DIR=Italian
     ;;
  ja*)
     DIR=Japanese
     ;;
  kr*)
     DIR=Korean
     ;;
  pl*)
     DIR=Polish
     ;;
  pt*)
     DIR=Portuguese
     ;;
  ro*)
     DIR=Romanian
     ;;
  ru*)
     DIR=Russian-koi8-r
     ;;
  sr*)
     DIR=Serbian
     ;;
  sk*)
     DIR=Slovak
     ;;
  es*)
     DIR=Spanish
     ;;
  sv*)
     DIR=Swedish
     ;;
  zh_TW*)
     DIR=Traditional_Chinese
     ;;
  zh_CN*)
     DIR=Simplify_Chinese
     ;;
  tr*)
     DIR=Turkish
     ;;
  greek)
     DIR=Greek
     ;;
  *)
     DIR=English
     ;;
esac

POST_ERROR_MESSAGE="ERROR: Proceed with care: frontier-squid post scriptlet failed. Dangling installation; If you are upgrading, previous release is still installed (and may run)."

cd %{etcdirsquid}
ln -snf ../..%{datadirsquid}/errors/$DIR errors
# Variables for unproto
export UNPROTO_VARS="NET_LOCAL CACHE_MEM CACHE_DIR_SIZE EFFECTIVE_USER EFFECTIVE_GROUP ETC_DIR LIBEXEC_DIR LOG_DIR SHARE_DIR CACHE_DIR BIN_DIR CONF_DIR SBIN_DIR CRON_DIR RUN_DIR AWSTATS_SCRIPT"

%{nodup1}

export NET_LOCAL="10.0.0.0/8 172.16.0.0/12 192.168.0.0/16"
export CACHE_MEM=128			# Alternative: "128 MB" 
export CACHE_DIR_SIZE=10000		# Alternative: 15000
export EFFECTIVE_USER=$FRONTIER_USER
export FRONTIER_GROUP=`id -ng $FRONTIER_USER`
export EFFECTIVE_GROUP=$FRONTIER_GROUP
export ETC_DIR=%{etcdirsquid}
export LIBEXEC_DIR=${RPM_INSTALL_PREFIX_}%{libexecdirsquid}
export LOG_DIR=${RPM_INSTALL_PREFIX_}%{logdirsquid}
export SHARE_DIR=${RPM_INSTALL_PREFIX_}%{datadirsquid}
export CACHE_DIR=${RPM_INSTALL_PREFIX_}%{cachedirsquid}
export BIN_DIR=${RPM_INSTALL_PREFIX_}/usr/sbin
export CONF_DIR=%{etcdirsquid}
export SBIN_DIR=${RPM_INSTALL_PREFIX_}/usr/sbin
export CRON_DIR=${RPM_INSTALL_PREFIX_}/etc/squid/cron
export RUN_DIR=${RPM_INSTALL_PREFIX_}%{rundirsquid}
export AWSTATS_SCRIPT=${RPM_INSTALL_PREFIX_}/etc/awstats/run_awstats.sh

%{etcdirsquid}/postinstall.sh
status=$?
if [ $status != 0 ] ; then
    echo "${POST_ERROR_MESSAGE}"
    exit 1
fi

%preun
#%sourceConfig
if [ $1 -eq 0 ]; then
   serv=`eval service frontier-squid status 2>/dev/null`
   if [ "x${serv}" = "xFrontier Squid is running" ]; then
      echo "Stopping the frontier-squid service"
      /sbin/service frontier-squid stop || exit 0
   fi
   serv=`eval chkconfig --list frontier-squid 2>/dev/null | awk -F" " '{print $1}'`
   if [ "x${serv}" = "xfrontier-squid" ]; then
      echo "Removing the frontier-squid service"
      /sbin/chkconfig --del frontier-squid
   fi

   # The following intends to avoid missing old squid.conf at upgrade.
   if [ -f %{etcdirsquid}/squid.conf.old ]; then 
       /bin/cp %{etcdirsquid}/squid.conf `mktemp /tmp/squid.confXXXX` 
   fi
fi

%postun
%sourceConfig
if [ $1 -eq 0 ]; then
   #/bin/rm -f /etc/init.d/frontier-squid
   /bin/rm -f /etc/init.d/frontier-squid* #Adding * because somehow, there was a /etc/init.d/frontier-squid.sh symbolic link
   /bin/rm -f %{etcdirsquid}/squid.conf.frontierdefault
   /bin/rm -f ${RPM_INSTALL_PREFIX}%{etcdirsquid}/errors
   /bin/rm -f ${RPM_INSTALL_PREFIX}%{etcdirsquid}/cron/crontab.dat
   /bin/rm -f ${RPM_INSTALL_PREFIX}%{etcdirsquid}/cron/daily.sh
   /bin/rm -f ${RPM_INSTALL_PREFIX}%{etcdirsquid}/cron/hourly.sh
   /bin/rm -f ${RPM_INSTALL_PREFIX}%{etcdirsquid}/init.d/frontier-squid.sh
   /bin/rm -f ${RPM_INSTALL_PREFIX}/usr/sbin/fn-local-squid.sh

   /bin/rm -fr ${RPM_INSTALL_PREFIX}%{etcdirsquid}/cron # Contains: daily.log*
   /bin/rm -fr ${RPM_INSTALL_PREFIX}%{etcdirsquid}/init.d # Exists, and is empty
   /bin/rm -fr ${RPM_INSTALL_PREFIX}%{libexecdirsquid}

   # Some of the following may not represent the dirs that are actually being used,
   # if these directories are changed at /etc/squid/customize.sh
   /bin/rm -fr ${RPM_INSTALL_PREFIX}%{datadirsquid}
   /bin/rm -fr ${RPM_INSTALL_PREFIX}%{cachedirsquid}
   /bin/rm -fr ${RPM_INSTALL_PREFIX}%{logdirsquid}
   /bin/rm -fr ${RPM_INSTALL_PREFIX}%{rundirsquid}


   # The following intends to avoid missing old squid.conf at upgrade.
   if [ -f %{etcdirsquid}/squid.conf.old ]; then 
       /bin/mv %{etcdirsquid}/squid.conf.old `mktemp /tmp/squid.conf.oldXXXX` 
   fi

   if [ -e "/var/spool/cron/${FRONTIER_USER}" ]; then
      echo "Removing relative cron job lines for the squid user ..."
      sed -i '/^7 7.*etc\/squid\/cron\/daily.sh/d' /var/spool/cron/${FRONTIER_USER} 
      sed -i '/^8.*etc\/squid\/cron\/hourly.sh/d' /var/spool/cron/${FRONTIER_USER}
   fi
fi
#
